# NOTE: this class has been translated from Java.
# Do not modify this file, changes will be overwritten.

#package orbitgt.mapping3d.sdk.viewer;

from .....com.orbitgis.lib.lang.RuntimeException import RuntimeException
from .....orbitgt.mapping3d.sdk.viewer.AList import AList
from .....orbitgt.mapping3d.sdk.viewer.AMap import AMap
from .....orbitgt.mapping3d.sdk.viewer.Bounds import Bounds
from .....orbitgt.mapping3d.sdk.viewer.Color import Color
from .....orbitgt.mapping3d.sdk.viewer.Coordinate import Coordinate
from .....orbitgt.mapping3d.sdk.viewer.CoordinatePart import CoordinatePart
from .....orbitgt.mapping3d.sdk.viewer.CoordinatePath import CoordinatePath
from .....orbitgt.mapping3d.sdk.viewer.Error import Error
from .....orbitgt.mapping3d.sdk.viewer.IList import IList
from .....orbitgt.mapping3d.sdk.viewer.IMap import IMap
from .....orbitgt.mapping3d.sdk.viewer.MapObject import MapObject
from .....orbitgt.mapping3d.sdk.viewer.MeasureProperty import MeasureProperty
from .....orbitgt.mapping3d.sdk.viewer.MeasureState import MeasureState
from .....com.orbitgis.tool.Strings import Strings

#
# Class Collections defines utility methods for lists and maps.
#

class Collections:
    # The generic type of objects */
    TYPE_OBJECT: str = "_o"
    # The generic type of strings */
    TYPE_STRING: str = "_s"
    # The generic type of integers */
    TYPE_INT: str = "_i"
    # The generic type of floats */
    TYPE_FLOAT: str = "_f"
    # The generic type of booleans */
    TYPE_BOOLEAN: str = "_b"
    # The serial type of list objects */
    TYPE_LIST: str = "AL"
    # The serial type of map objects */
    TYPE_MAP: str = "AM"

    #
    # Create a new list.
    # @param genericType the generic type of the elements, like MapOject.TYPE for example.
    # @return the list.
    #
    def createList(genericType: str) -> IList:
        if (Strings.equals(genericType,Collections.TYPE_OBJECT)): return AList[object](genericType)
        if (Strings.equals(genericType,Collections.TYPE_STRING)): return AList[str](genericType)
        if (Strings.equals(genericType,Collections.TYPE_INT)): return AList[Integer](genericType)
        if (Strings.equals(genericType,Collections.TYPE_FLOAT)): return AList[Double](genericType)
        if (Strings.equals(genericType,Collections.TYPE_BOOLEAN)): return AList[Boolean](genericType)
        if (Strings.equals(genericType,Bounds.TYPE)): return AList[Bounds](genericType)
        if (Strings.equals(genericType,Color.TYPE)): return AList[Color](genericType)
        if (Strings.equals(genericType,Coordinate.TYPE)): return AList[Coordinate](genericType)
        if (Strings.equals(genericType,CoordinatePart.TYPE)): return AList[CoordinatePart](genericType)
        if (Strings.equals(genericType,CoordinatePath.TYPE)): return AList[CoordinatePath](genericType)
        if (Strings.equals(genericType,Error.TYPE)): return AList[Error](genericType)
        if (Strings.equals(genericType,MapObject.TYPE)): return AList[MapObject](genericType)
        if (Strings.equals(genericType,MeasureProperty.TYPE)): return AList[MeasureProperty](genericType)
        if (Strings.equals(genericType,MeasureState.TYPE)): return AList[MeasureState](genericType)
        raise RuntimeException("Cannot create list of type: "+genericType)

    #
    # Create a new map.
    # @param genericType the generic type of the elements, like MapOject.TYPE for example.
    # @return the map.
    #
    def createMap(genericType: str) -> IMap:
        if (Strings.equals(genericType,Collections.TYPE_OBJECT)): return AMap[object](genericType)
        if (Strings.equals(genericType,Collections.TYPE_STRING)): return AMap[str](genericType)
        if (Strings.equals(genericType,Collections.TYPE_INT)): return AMap[Integer](genericType)
        if (Strings.equals(genericType,Collections.TYPE_FLOAT)): return AMap[Double](genericType)
        if (Strings.equals(genericType,Collections.TYPE_BOOLEAN)): return AMap[Boolean](genericType)
        if (Strings.equals(genericType,Bounds.TYPE)): return AMap[Bounds](genericType)
        if (Strings.equals(genericType,Color.TYPE)): return AMap[Color](genericType)
        if (Strings.equals(genericType,Coordinate.TYPE)): return AMap[Coordinate](genericType)
        if (Strings.equals(genericType,CoordinatePart.TYPE)): return AMap[CoordinatePart](genericType)
        if (Strings.equals(genericType,CoordinatePath.TYPE)): return AMap[CoordinatePath](genericType)
        if (Strings.equals(genericType,Error.TYPE)): return AMap[Error](genericType)
        if (Strings.equals(genericType,MapObject.TYPE)): return AMap[MapObject](genericType)
        if (Strings.equals(genericType,MeasureProperty.TYPE)): return AMap[MeasureProperty](genericType)
        if (Strings.equals(genericType,MeasureState.TYPE)): return AMap[MeasureState](genericType)
        raise RuntimeException("Cannot create map of type: "+genericType)
